SystemOrganization addCategory: #'EC-Profiling'!

Profiler subclass: #ECProfiler
	instanceVariableNames: 'versionNumber timeMode'
	classVariableNames: 'version'
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECProfiler class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:49'!
createProfiler: regexp
	""
	self  installOnPackagesMatching: regexp.
	version :=0.
	^ self gatherForPackagesMatching: regexp.
! !

!ECProfiler class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:49'!
destroyProfiler: regexp
	""
	self removeFromPackagesMatching: regexp ! !

!ECProfiler class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:58'!
profile: aBlock inPackagesMatching: regexp with: profiler
	| messageTally tally |
	version := version + 1.
	profiler timeMode.	
	Transcript show: 'time..'; cr.
	[
		profiler beforeProfiling.
		aBlock value.
		profiler afterProfiling  ]
	ensure: [ ].
	profiler checkInvariant.
	
	profiler dataMode.
	Transcript show: 'data...'; cr.
	[
		profiler beforeProfiling.
		aBlock value.
		profiler afterProfiling  ]
	ensure: [ 
		Transcript show: 'Version It';cr.
		profiler allMethods do:[ :each| each versionIt: version.]. 
	].
	Transcript show: 'ended...'; cr.
	profiler checkInvariant.
	
	^ profiler! !

!ECProfiler class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:46'!
spyClassForPackage
	^ ECPackage.! !

!ECProfiler methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:49'!
dataMode
	timeMode := false.! !

!ECProfiler methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:49'!
initialize 
	""
	versionNumber := 0.
	timeMode := true.! !

!ECProfiler methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:51'!
isTimeMode
	^timeMode.! !

!ECProfiler methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:49'!
timeMode
	timeMode := true.! !

MethodSpy subclass: #ECMethod
	instanceVariableNames: 'versions cProfiledData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECMethod class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/18/2011 21:59'!
spyClassForMethod
	^ self! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/19/2011 12:55'!
identifier
	^ (self theClass name asString), '>>' , (self selector asString ).! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:56'!
initialize 
	super initialize.
	
	versions := OrderedCollection  new.
	cProfiledData := ProfiledData new.! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:54'!
run: methodName with: listOfArguments in: receiver
	| v t|

	self beforeRun: methodName with: listOfArguments in: receiver.
	self classSpy ifNotNil: [
		classSpy beforeEachExecution: methodName On: receiver with: listOfArguments ].
	
	t := Time primMillisecondClock.
	
	(self profiler isTimeMode) ifTrue: [	
		cProfiledData numberOfMessage: (cProfiledData numberOfMessage + 1).
			
		].
	
	v := originalMethod valueWithReceiver: receiver arguments: listOfArguments.
	
	t := (Time primMillisecondClock) - t.
	
	cProfiledData time: (cProfiledData time + t).
	
	(self profiler isTimeMode) ifTrue: [
		
		].
	
	self afterRun: methodName with: listOfArguments in: receiver.
	
	self classSpy ifNotNil: [ 
		classSpy afterEachExecution: methodName On: receiver with: listOfArguments ].
	self returnValue: v.

	^ v! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 11:52'!
var
	|avg|
	avg := versions inject: 0 into: 	[:inj :data| inj + data time].
	^ versions inject: 0 into: [ :inj :data | inj+ (avg - (data time))*(avg - (data time))].
! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 20:12'!
versionIt: number
	"New profiled Data"
	"versions put: cProfiledData at: number."
	cProfiledData version: number.
	versions add: cProfiledData.
	cProfiledData := ProfiledData new.! !

!ECMethod methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:25'!
versions
	^ versions.! !

PackageSpy subclass: #ECPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECPackage class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/18/2011 21:58'!
spyClassForClass
	^ ECClass! !

Object subclass: #ECBrowser
	instanceVariableNames: 'ecProfiler nodes versionNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 16:07'!
buildBrowser
	|browser|
	browser := GLMTabulator new.
	browser title: ' Diff Profiling '.
	browser
		row: [ :r |
				r column: #method span: 3.
				r column: #result span: 8. ] span: 6;
		row: [ :r | 
				r column: #versions span: 3.
				r column: #data span: 8. 
			] span: 2.
		
	browser transmit 
		to: #method;
		fromOutsidePort: #entity;
		andShow: [ : a| self displayMethod: a.].
		
	
	browser transmit
		to: #result;
		from: #method;
		andShow: [ :a | self eyesseIn: a ].

	browser transmit
		to: #versions;
		from: #method;
		andShow: [ :a | self versionsIn: a ].
			
	browser transmit 
		to: #data;
		from: #versions;
		andShow:[ :a | self dataIn: a].		

	^ browser! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 18:56'!
close
	ECProfiler destroyProfiler: 'EyeSee-*'.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/19/2011 14:46'!
colors
	|colors|
	colors := OrderedCollection new.
	colors add:(Color blue).
	colors add:(Color red).
	colors add:(Color green).
	colors add:(Color pink).
	^colors.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 15:07'!
createDiagram: method with: aColor
	| diag |
	diag := (ESDiagramRenderer new lineDiagram).
	diag
		y: [: model| model  time];
		identifier: #version;
		yAxisLabel: 'Time';
		rotatedLabels: true;
		defaultColor: aColor;
		models: (method versions).	
	(aColor = Color red) ifTrue: [diag regularAxis. ].
	
	^diag.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 15:18'!
dataIn: presentation
	^ presentation list
				display:[ :pd |
					{ 'numberOfMessage' -> pd numberOfMessage }
					].! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 15:09'!
displayMethod: presentation
	^ presentation list
"		title: 'Methods';"
		display: [ :env | self methods ];
		format: [ :m | m selector].
"		sorted: [ :a1 :b | a1 var > b var ];
		format: [ :method | method selector]."
		! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 11:53'!
eyesseIn: presentation
      ^ presentation eyesee
						diagram: [:renderer :method|
							|compose diag|	
							compose := renderer compositeDiagram.
							self methods do: [ :m|								
									(m=method) ifTrue:[
									] ifFalse:[
										diag := self createDiagram: m with: Color blue. 
									]. 
									compose add: diag.
							].
							diag := self createDiagram: method with: Color red.
							compose add: diag.
							compose 
								height: 400;
								width: 500.
							compose.
							].
									
								! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 11:34'!
initialize 
	super initialize.
	ecProfiler := ECProfiler createProfiler: 'EyeSee-*'.
	
	Transcript show: (ecProfiler allMethods size) asString ;cr.
	
	nodes := OrderedCollection new.
	versionNumber := 0.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:18'!
methods
	""
	^ ((ecProfiler allMethods) asSortedCollection: [ :A :B | (A var) > (B var) ]) first: 10.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/19/2011 16:08'!
printString
	^ '*'! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 11:57'!
profile: aScript
	self profile: aScript withBinding: (OrderedCollection new).! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:55'!
profile: aScript withBinding: collection
	|context version method|
	context := GLMContext withAll: collection.
	
	Transcript show:'Profile';cr.
	ECProfiler profile: [
		Compiler new evaluate: aScript in: context to: context.
	]inPackagesMatching: 'EyeSee-*' with: ecProfiler.! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:17'!
scriptIn: aPresentation
	""
	^ aPresentation smalltalkCode
			variableBindings: [ :bindings | 
					| col |
					col := OrderedCollection withAll: bindings.
					col ];
			with: [: p | p display: '  "Insert your code" ' ];
			populate: #selection
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Generate'
			with: [ :text | text text ].! !

!ECBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 15:20'!
versionsIn: presentation
	^ presentation list
					display: [ :method | method versions];
					format: [ :pd | pd version asString ].
		! !

Object subclass: #ECTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECTests methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 15:21'!
demo
	|browser context binding|
	browser := ECBrowser new.
	context := OrderedCollection new.

	(1 to: 10) do:[ :x|
		binding :={ #y 		-> (x*100). #b ->(ECTests new) }.
		browser profile: 'b lineDiagram: y.' withBinding: binding.
	].

	(browser buildBrowser)  openOn: context.
	ECProfiler destroyProfiler: 'EyeSee-*'.! !

!ECTests methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 16:56'!
lineDiagram: aNumber
	| diag browser|

	diag := ESDiagramRenderer new.
	(diag lineDiagram)
		y: #loc;
		identifier: #versionNumber;
		yAxisLabel: 'LoC';
		rotatedLabels: true;
		regularAxis;
		defaultColor: Color blue;
		deviationValue: (self versions collect: #loc) average;
		deviationDescription: 'average';
		preferredAxisMinY: (self versions minValue: #loc);
		models: (self versions: aNumber).	"startLineAtZero;"
	browser := diag open.
	browser delete.
	! !

!ECTests methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 22:45'!
versions
	
	| versions |
	versions := OrderedCollection new.
	versions
		add:
				((ESVersion new)
						versionNumber: '1.0';
						loc: 3346);
		add:
				((ESVersion new)
						versionNumber: '1.1';
						loc: 3455);
		add:
				((ESVersion new)
						versionNumber: '1.2';
						loc: 3755);
		add:
				((ESVersion new)
						versionNumber: '1.3';
						loc: 4674);
		add:
				((ESVersion new)
						versionNumber: '1.4';
						loc: 4738);
		add:
				((ESVersion new)
						versionNumber: '1.5';
						loc: 4378);
		add:
				((ESVersion new)
						versionNumber: '1.6';
						loc: 4890);
		add:
				((ESVersion new)
						versionNumber: '1.7';
						loc: 4908);
		add:
				((ESVersion new)
						versionNumber: '1.8';
						loc: 5013).
	^versions! !

!ECTests methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 14:20'!
versions: n
	
	| versions rnd|
	versions := OrderedCollection new.
	rnd := Random new.
	(1 to: n) do: [ :x |		
		versions
		add:
				((ESVersion new)
						versionNumber: x asString;
						loc: (rnd nextInt: 500)).
		].
	^versions! !

Object subclass: #ProfiledData
	instanceVariableNames: 'time numberOfMessage version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ProfiledData methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:51'!
initialize 
	super initialize.
	numberOfMessage := 0.
	time :=0.
	version :=0.! !

!ProfiledData methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 18:13'!
numberOfMessage
	^ numberOfMessage! !

!ProfiledData methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 18:13'!
numberOfMessage: anObject
	numberOfMessage := anObject! !

!ProfiledData methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 18:13'!
time
	^ time! !

!ProfiledData methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 18:13'!
time: anObject
	time := anObject! !

!ProfiledData methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:24'!
version
	^version! !

!ProfiledData methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/20/2011 19:25'!
version: aNumber
	version :=aNumber! !

Object subclass: #Readme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!Readme methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/21/2011 18:59'!
readme
	"
	Tengo un unico demo... de momento... para ver el demo tiene que ejecutar esta linea	
	===>     ECTests new demo
	Aparecera un browser con 4 secciones
	_______
	|   1    |  2  |
	_______
	|  3    |  4  |
	_______
	
	En la seccion 1 se encuentran los 10 metodos que tuvieron una mayor varianza en las 10 ejecuciones.
	En la seccion 2 se muestra una grafica con el siguiente detalle:
	       - eje Y:  tiempo
	       - eje X: version
	       - cada linea representa un metodo.
	En la seccion 3 se muestra una lista de versiones (1 to: 10)
	Y finalmente en la seccion 4 se puede ver el numero de mensajes que recibio el metodo seleccionado en la seccion 1 en la version seleccionada en la seccion 3.
	"! !

ClassSpy subclass: #ECClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EC-Profiling'!

!ECClass class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/18/2011 21:59'!
spyClassForMethod
	^ ECMethod ! !
